﻿package  
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.utils.Timer;
	import org.cove.ape.*;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import classes.base.Bubbles;
	
	public class Main extends MovieClip
	{
		private var acquaplayGroup:Group;
		private var bRollBack:Boolean		= false;
		private var bPressed:Boolean		= false;
		
		private var iLeftTimeOut:Timer		= new Timer(1500);
		private var iRightTimeOut:Timer		= new Timer(1500);
		
		private var bLeftPress:Boolean		= false;
		private var bRightPress:Boolean		= false;
		
		private var bLeftForce:Boolean		= false;
		private var bRightForce:Boolean		= false;
		
		private var managerBubbles:Bubbles;
		
		private var secondsCounter:Timer	= new Timer(1000);
		private var iSecondsCounter:Number		= 0;
		
		
		private var arrBallPoints:Array		= new Array(false, false, false, false);
		
		public function Main()  
		{
			stage.quality		= "BEST";
			startAPEEngine()
			createAcquaplay();
			managerBubbles		= new Bubbles(acquaplay.Bubbles);
			
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyInterac);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyInterac);
				
			iLeftTimeOut.addEventListener(TimerEvent.TIMER, leftTimeOutPress);
			iRightTimeOut.addEventListener(TimerEvent.TIMER, rightTimeOutPress);
			
			
			secondsCounter.addEventListener(TimerEvent.TIMER, onTimer);
			secondsCounter.start();
		}
		private function onTimer(te:TimerEvent):void
		{
			var showSeconds:String;
			var showMinutes:String;
			
			iSecondsCounter++;
			if ((iSecondsCounter%60) < 10)
			{
				showSeconds = "0" + String(iSecondsCounter%60);
			}
			else
			{
				showSeconds = String(iSecondsCounter%60)
			}
			
			
			var minutes:Number = Math.floor(iSecondsCounter / 60);
			if (minutes < 10)
			{
				showMinutes = "0" + String(minutes);
			}
			else
			{
				showMinutes = String(minutes);
			}
			
			acquaplay.timerShow.text = showMinutes + ":" + showSeconds;
		}
		private function press(side:String):void
		{
			switch(side)
			{
				case "left":
					bLeftPress = true;
					bLeftForce = true;
					acquaplay.leftButton.play();
					iLeftTimeOut.reset();
					iLeftTimeOut.start();
				break;
				case "right":
					bRightPress = true;
					bRightForce	= true;
					
					acquaplay.rightButton.play();
					iRightTimeOut.reset();
					iRightTimeOut.start();
				break;
			}
			managerBubbles.press(side);
		}
		private function release(side:String)
		{
			switch(side)
			{
				case "left":
					bLeftPress = false;
					bLeftForce = false;
					acquaplay.leftButton.addEventListener(Event.ENTER_FRAME, rollBack);
				break;
				case "right":
					bRightPress	= false;
					bRightForce	= false;
					acquaplay.rightButton.addEventListener(Event.ENTER_FRAME, rollBack);
				break;
			}
			managerBubbles.release(side);
		}
		private function keyInterac(ke:KeyboardEvent):void
		{
			switch(ke.type)
			{
				
				case "keyDown":
					switch(ke.keyCode)
					{
						case 37:
							if (!bLeftPress)
							{
								press("left");
							}
						break;
						case 39:
							if (!bRightPress)
							{
								press("right");
							}
						break;
					}
				break;
				case "keyUp":
					switch(ke.keyCode)
					{
						case 37:
							release("left");
						break;
						case 39:
							release("right");
						break;
					}
				break;
			}
		}
		private function startAPEEngine():void
		{
			APEngine.init();
			APEngine.container = this.acquaplay.APEcontainer;
			APEngine.addForce(new VectorForce(false, 0, 1));
			this.addEventListener(Event.ENTER_FRAME, run);
		}
		private function leftTimeOutPress(te:TimerEvent):void
		{
			bLeftForce = false;
			iLeftTimeOut.stop();
			managerBubbles.release("left");
			//release("left");
		}
		private function rightTimeOutPress(te:TimerEvent):void
		{
			bRightForce = false;
			iRightTimeOut.stop();
			managerBubbles.release("right");
			//release("right");
		}
		private function rollBack(e:Event):void
		{
			var mc:MovieClip = MovieClip(e.target);
			if (e.target.currentFrame > 1)
			{
				e.target.prevFrame();
			}
			else
			{
				e.target.removeEventListener(Event.ENTER_FRAME, rollBack);
			}
		}
		private function createAcquaplay():void
		{
			acquaplayGroup = new Group();
			acquaplayGroup.collideInternal = true;
			APEngine.addGroup(acquaplayGroup);
			
			
			//Creating Balls;
			var ball1Display:DisplayObject = new bola1();
			var ball2Display:DisplayObject = new bola2();
			var ball3Display:DisplayObject = new bola3();
			var ball4Display:DisplayObject = new bola4();
			
			var ball1:CircleParticle = new CircleParticle(70, 125, 6, false, 1, 0);
			var ball2:CircleParticle = new CircleParticle(87, 125, 6, false, 1, 0);
			var ball3:CircleParticle = new CircleParticle(105, 125, 6, false, 1, 0);
			var ball4:CircleParticle = new CircleParticle(121, 125, 6, false, 1, 0);
			
			ball1.sprite.name = "ball1";
			ball2.sprite.name = "ball2";
			ball3.sprite.name = "ball3";
			ball4.sprite.name = "ball4";
			
			
			ball1.setDisplay(ball1Display, 0, 0, 0);
			ball2.setDisplay(ball2Display, 0, 0, 0);
			ball3.setDisplay(ball3Display, 0, 0, 0);
			ball4.setDisplay(ball4Display, 0, 0, 0);
			
			
			
			acquaplayGroup.addParticle(ball1);
			acquaplayGroup.addParticle(ball2);
			acquaplayGroup.addParticle(ball3);
			acquaplayGroup.addParticle(ball4);
			
			//Creating Wall and obstacles
			var lWall:RectangleParticle = new RectangleParticle(8, 85, 1, 134, -.05, true);
			var rWall:RectangleParticle = new RectangleParticle(188, 85, 1, 134, .05, true);
			var tWall:RectangleParticle = new RectangleParticle(100, 18, 200, 1, 0, true);
			var bWall:RectangleParticle = new RectangleParticle(100, 153, 185, 1, 0, true);
			var blColision:RectangleParticle = new RectangleParticle(60, 142, 75, 0.5, -.13, true, 1, 0.0);
			var brColision:RectangleParticle = new RectangleParticle(133, 142, 75, 0.5, .13, true, 1, 0.0);
			
			rWall.setLine(0.1, 0x000, 0);
			tWall.setLine(0.1, 0x000, 0);
			lWall.setLine(0.1, 0x000, 0);
			bWall.setLine(0.1, 0x000, 0);
			blColision.setLine(1, 0x000, 0);
			brColision.setLine(1, 0x000, 0);
			
			acquaplayGroup.addParticle(lWall);
			acquaplayGroup.addParticle(rWall);
			acquaplayGroup.addParticle(tWall);
			acquaplayGroup.addParticle(bWall);
			
			acquaplayGroup.addParticle(blColision);
			acquaplayGroup.addParticle(brColision);
			
			
			var ob1left:RectangleParticle = new RectangleParticle(63, 82, 1, 20, 0, true);
			var ob1right:RectangleParticle = new RectangleParticle(80, 82, 1, 20, 0, true);
			var ob1Ldown:RectangleParticle = new RectangleParticle(68, 95, 10, 1, .6, true);
			var ob1Rdown:RectangleParticle = new RectangleParticle(75, 95, 10, 1, -.6, true);
			
			
			var ob2left:RectangleParticle = new RectangleParticle(120, 62, 1, 20, 0, true);
			var ob2right:RectangleParticle = new RectangleParticle(137, 62, 1, 20, 0, true);
			var ob2Ldown:RectangleParticle = new RectangleParticle(125, 75, 10, 1, .6, true);
			var ob2Rdown:RectangleParticle = new RectangleParticle(132, 75, 10, 1, -.6, true);
			
			
			ob2left.setLine(0.1, 0x000, 0);
			ob2right.setLine(0.1, 0x000, 0);
			ob2Ldown.setLine(0.1, 0x000, 0);
			ob2Rdown.setLine(0.1, 0x000, 0);
			
			ob1left.setLine(0.1, 0x000, 0);
			ob1right.setLine(0.1, 0x000, 0);
			ob1Ldown.setLine(0.1, 0x000, 0);
			ob1Rdown.setLine(0.1, 0x000, 0);
			
			acquaplayGroup.addParticle(ob2left);
			acquaplayGroup.addParticle(ob2right);
			acquaplayGroup.addParticle(ob2Ldown);
			acquaplayGroup.addParticle(ob2Rdown);
			
			acquaplayGroup.addParticle(ob1left);
			acquaplayGroup.addParticle(ob1right);
			acquaplayGroup.addParticle(ob1Ldown);
			acquaplayGroup.addParticle(ob1Rdown);
			
			
		}
		private function run(e:Event):void
		{
			APEngine.step();
			APEngine.paint();
			
			
			var tempCounter:Number = 0;
			for each(var value:Boolean in arrBallPoints)
			{
				if (value)
				{
					tempCounter++;
				}
			}
			
			if (tempCounter == 4)
			{
				this.removeEventListener(Event.ENTER_FRAME, run);
				secondsCounter.stop();
				trace("End Game");
			}
			
			for each(var p:AbstractParticle in acquaplayGroup.particles)
			{
				if (p.fixed == false)
				{
					//Check Forces
					
					if (p.px > 145 && p.px < 185 && p.py < 50 && p.py > 20)
					{
						p.addForce(new VectorForce(false, -.5, 0.5));
					}
					else if (p.px > 4 && p.px < 62 && p.py < 50 && p.py > 20)
					{
						p.addForce(new VectorForce(false, .5, 0.5));
					}
					if (bLeftForce)
					{
						if (p.px > 15 && p.px < 30 && p.py > 50)
						{
							p.addForce(new VectorForce(false, 0, -4));
						}
						if (p.px > 4 && p.px < 62 && p.py < 50 && p.py > 20)
						{
							p.addForce(new VectorForce(false, 2, 0));
						}
					}
					if (bRightForce)
					{
						if (p.px > 168 && p.px < 180 && p.py > 50)
						{
							p.addForce(new VectorForce(false, 0, -4));
						}
						if (p.px > 145 && p.px < 185 && p.py < 50 && p.py > 20)
						{
							p.addForce(new VectorForce(false, -2, 0));
						}
					}
					//Check Points
					if (p.px > 69 && p.px < 73 && p.py > 75 && p.py < 90)
					{
						switch(p.sprite.name)
						{
							case "ball1":
								if (!arrBallPoints[0])
								{
									trace("Point LEFT");
									arrBallPoints[0] = true;
								}
							break;
							case "ball2":
								if (!arrBallPoints[1])
								{
									trace("Point LEFT");
									arrBallPoints[1] = true;
								}
							break;
							case "ball3":
								if (!arrBallPoints[2])
								{
									trace("Point LEFT");
									arrBallPoints[2] = true;
								}
							break;
							case "ball4":
								if (!arrBallPoints[3])
								{
									trace("Point LEFT");
									arrBallPoints[3] = true;
								}
							break;
						}
					}
					if (p.px > 125 && p.px < 129 && p.py > 56 && p.py < 68)
					{
						
						switch(p.sprite.name)
						{
							case "ball1":
								if (!arrBallPoints[0])
								{
									trace("Point RIGHT")
									arrBallPoints[0] = true;
								}
							break;
							case "ball2":
								if (!arrBallPoints[1])
								{
									trace("Point RIGHT")
									arrBallPoints[1] = true;
								}
							break;
							case "ball3":
								if (!arrBallPoints[2])
								{
									trace("Point RIGHT")
									arrBallPoints[2] = true;
								}
							break;
							case "ball4":
								if (!arrBallPoints[3])
								{
									trace("Point RIGHT")
									arrBallPoints[3] = true;
								}
							break;
						}
					}
				}
				
				
			}
		}
	}
	
}
