﻿package classes.base 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	/**
	* ...
	* @author Bruno André Mikoski
	*/
	public class Bubbles 
	{
		private var bubblesContainer:MovieClip;
		private var normalInterval:Timer;
		private var pressLeftInterval:Timer;
		private var pressRightInterval:Timer;
		
		public function Bubbles(p_Target:MovieClip) 
		{
			bubblesContainer	= p_Target;
			normalInterval		= new Timer(1000);
			pressLeftInterval		= new Timer(100);
			pressRightInterval		= new Timer(100);
			
			
			normalInterval.addEventListener(TimerEvent.TIMER, addBubbleRandomBubble);
			pressLeftInterval.addEventListener(TimerEvent.TIMER, addBubbleLeft);
			pressRightInterval.addEventListener(TimerEvent.TIMER, addBubbleRight);
			normalInterval.start()
		}
		public function press(side:String):void
		{
			switch(side)
			{
				case "left":
					pressLeftInterval.start();
				break;
				case "right":
					pressRightInterval.start();
				break;
			}
			//pressInterval.start();
		}
		public function release(side:String):void
		{
			switch(side)
			{
				case "left":
					pressLeftInterval.stop();
				break;
				case "right":
					pressRightInterval.stop();
				break;
			}
		}
		private function addBubbleRandomBubble(te:TimerEvent):void
		{
			
			var chance:Number =  Math.floor(Math.random() * 2+1);
			
			var emptyTimeEvent:TimerEvent
			switch(chance)
			{
				case 1:
					addBubbleRight(emptyTimeEvent);
				break;
				case 2:
					addBubbleLeft(emptyTimeEvent);
				break;
			}
		}
		private function addBubbleRight(te:TimerEvent):void
		{
			var myBubble:MovieClip	= MovieClip(new bubble());
			
			var randomScale:Number	= Math.random() * 0.2 + 0.2;
			
			myBubble.scaleX	= randomScale;
			myBubble.scaleY	= randomScale;
			
			myBubble.alpha	= .8;
			myBubble.x = Math.random() * 20 + 170;
			myBubble.y = 170;
			
			myBubble.addEventListener(Event.ENTER_FRAME, runBubble);
			bubblesContainer.addChild(myBubble);
		}
		private function addBubbleLeft(te:TimerEvent):void
		{
			var myBubble:MovieClip	= MovieClip(new bubble());
			
			var randomScale:Number	= Math.random() * 0.2 + 0.2;
			
			myBubble.scaleX	= randomScale;
			myBubble.scaleY	= randomScale;
			
			myBubble.alpha	= .5;
			myBubble.x = Math.random() * 20 + 10;
			myBubble.y = 170;
			
			myBubble.addEventListener(Event.ENTER_FRAME, runBubble);
			bubblesContainer.addChild(myBubble);
		}
		private function runBubble(e:Event):void
		{
			e.target.y -= 2;
			if (e.target.y < 0)
			{
				e.target.removeEventListener(Event.ENTER_FRAME, runBubble);
				e.target.parent.removeChild(e.target);

			}
		}
	}
	
}